var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var WebStorage =
/** @class */
function () {
  function WebStorage(props) {
    var _a = props.type,
        type = _a === void 0 ? 'sessionStorage' : _a,
        key = props.key;
    this._key = key;
    this.storage = window[type];
  }

  Object.defineProperty(WebStorage.prototype, "state", {
    get: function get() {
      var value = this.storage.getItem(this._key);

      if (value) {
        return JSON.parse(value);
      } else {
        return null;
      }
    },
    set: function set(data) {
      var temp = JSON.stringify(data);
      this.storage.setItem(this._key, temp);
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(WebStorage.prototype, "key", {
    get: function get() {
      return this._key;
    },
    enumerable: false,
    configurable: true
  });

  WebStorage.prototype.merge = function (data) {
    var old = this.state;
    this.state = __assign(__assign({}, old), data);
  };

  WebStorage.prototype.clear = function () {
    this.storage.removeItem(this._key);
  };

  return WebStorage;
}();

export { WebStorage };