"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.blob2file = exports.blob2base64 = exports.blob2text = void 0;

exports.blob2text = function (blob) {
  return new Promise(function (resolve) {
    var reader = new FileReader();

    reader.onload = function (e) {
      return resolve(e.target.result);
    };

    reader.readAsText(blob);
  });
};

exports.blob2base64 = function (blob) {
  return new Promise(function (resolve, reject) {
    var reader = new FileReader();

    if (!blob) {
      reject('文件爲空!');
    } else {
      reader.onload = function (e) {
        return resolve(e.target.result);
      };

      reader.onabort = function () {
        return reject();
      };

      reader.readAsDataURL(blob);
    }
  });
};

exports.blob2file = function (blob, name, type) {
  return new File(blob, name, {
    type: type
  });
};