"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var pubo_utils_1 = require("pubo-utils");

var WebsocketClient =
/** @class */
function () {
  function WebsocketClient(_a) {
    var url = _a.url;
    this._status = 0;
    this.url = '';
    this.emitter = new pubo_utils_1.Emitter();
    this.url = url;
    this.connect();
  }

  WebsocketClient.prototype.reconnect = function () {
    var _this = this;

    if (this._status === 3) {
      setTimeout(function () {
        _this.connect();
      }, 1000);
    }
  };

  WebsocketClient.prototype.onClose = function () {
    if (this._status !== 2) {
      this._status = 3;
    }

    this.reconnect();
  };

  WebsocketClient.prototype.onMessage = function (e) {
    this.emitter.emit('message', e.data);
  };

  WebsocketClient.prototype.connect = function () {
    var _this = this;

    this.client = new WebSocket(this.url);
    this.client.onclose = this.onClose.bind(this);
    this.client.onmessage = this.onMessage.bind(this);

    this.client.onopen = function () {
      _this._status = 1;
    };
  };

  WebsocketClient.prototype.close = function () {
    if (this.client) {
      this.client.close();
      this.client = null;
      this._status = 2;
    }
  };

  WebsocketClient.prototype.send = function (data, isJson) {
    var _a;

    var res = data;

    if (isJson) {
      res = JSON.stringify(data);
    }

    (_a = this.client) === null || _a === void 0 ? void 0 : _a.send(res);
  };

  return WebsocketClient;
}();

exports["default"] = WebsocketClient;